
# Базовый синтаксис декоратора в python

def my_decorator(func):

    def wrapper_func():
        # Делаем что-то до вызова функции
        func()
        # Делаем что-то после вызова функции

    return wrapper_func


'''
def decorator(func):
    def wrapper():
        print('Start decorator')
        func()
        print('Finish decorator')
    return wrapper
'''

def decorator(func):
    def inner(*args, **kwargs):
        print('Стартуем декоратор')
        func(*args, **kwargs)
        print('Заканчиваем декоратор')
    return inner

@decorator
def say_hello_to(name, surname):
    print('hello', name, surname)



decorator
def my_func():
    print('This is my mega function!')


def main():
    say_hello_to('Vasya', 'Ivanov')


if __name__ == '__main__':
    main()